import es
import gamethread
import playerlib

class RespawnManager(object):
	def __init__(self):
		self.delays = {}
		self.mode = es.ServerVar('dd_dm_mode')
		self.waveTimeCur = es.ServerVar('dd_dm_delay')
		self.waveTimeMax = self.waveTimeCur
	
	def add(self,userid):
		self.delays[userid] = self.waveTimeMax if self.mode == 1 else self.waveTimeCur

	def remove(self,userid):
		if userid in self.delays: del self.delays[userid]

	def reduceTime(self):
		if self.mode != 2:
			self.tempDict = dict(self.delays)
			for userid in self.tempDict:
				self.delays[userid] -= 1
				if self.delays[userid] < 1: self.respawnPlayer(userid)
		else:
			self.waveTimeCur -= 1
			if self.waveTimeCur < 1:
				for userid in self.delays: self.respawnPlayer(userid)
				self.delays.clear()
				self.waveTimeCur = self.waveTimeMax

	def respawnPlayer(self,userid):
		if es.getuserid(userid):
			if playerlib.getPlayer(userid).get('isdead') and es.getplayerteam(userid) > 1:
				es.setplayerprop(userid,"CCSPlayer.m_iPlayerState",0)
				es.setplayerprop(userid,"CCSPlayer.baseclass.m_lifeState",512)
				es.server.queuecmd('es_xspawnplayer %s' % userid)

respawn = RespawnManager()

def player_spawn(ev):
	respawn.remove(int(ev['userid']))

def player_death(ev):
	respawn.add(int(ev['userid']))

def player_team(ev):
	userid = int(ev['userid'])
	if int(ev['team']) > 1: respawn.add(userid)
	else: respawn.remove(userid)

def player_disconnect(ev):
	respawn.remove(int(ev['userid']))